// DKMY.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <stdio.h>
#include "shellapi.h"

#include "DKMY.h"
#define MAX_LOADSTRING 64

// Global Variables:
HINSTANCE hInst;								// current instance
HMENU hMenu;									// application's menu
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

HMODULE				dllModuleH;
HHOOK				hookH;
HOOKPROC			shellProc;
NOTIFYICONDATA		notifyIconData;
TCHAR				bufferS[MAX_LOADSTRING];

HHOOK*				DkmyHookHP = NULL;
HWND*				DkmyLastHwndP = NULL;
DWORD*				DkmyNumInstancesP = NULL;
HWND				triggeringHwnd = NULL;


// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
VOID				ExitInstance();
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

BOOL				InstallShellHook();
VOID				RemoveShellHook();

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;

	// Initialize global strings
	LoadString(hInstance, IDC_DKMY, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	
	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) return FALSE;

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	ExitInstance();
	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_DKMY);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_DKMY;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	hInst = hInstance; // Store instance handle in our global variable

	hMenu = LoadMenu(hInst, (LPCTSTR)IDC_DKMY);
	if (hMenu == NULL) return FALSE;

	HWND hWnd = CreateWindow(szWindowClass, szWindowClass, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

	if (hWnd == NULL) {
		DestroyMenu(hMenu);
		hMenu = NULL;
		return FALSE;
	}
	if (!InstallShellHook()) {
		DestroyMenu(hMenu);
		hMenu = NULL;
		return FALSE;
	}

	notifyIconData.cbSize = sizeof(notifyIconData);
	notifyIconData.hWnd = hWnd;
	notifyIconData.uID = IDC_DKMY;
	notifyIconData.uCallbackMessage = WM_USER;
	notifyIconData.hIcon = LoadIcon(hInstance, (LPCTSTR)IDI_DKMY);
	lstrcpy(notifyIconData.szTip, "Dkmy");
	notifyIconData.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;

	Shell_NotifyIcon(NIM_ADD, &notifyIconData);	

	return TRUE;
}

VOID ExitInstance()
{
	if (hMenu) {
		DestroyMenu(hMenu);
		hMenu = NULL;
	}
	RemoveShellHook();
	Shell_NotifyIcon(NIM_DELETE, &notifyIconData);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	POINT pt;
	HMENU menuH;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;

		case IDM_LOCK_UNLOCK:
			if (triggeringHwnd != NULL && IsWindow(triggeringHwnd)) {
				UINT uFlags = GetWindowLong(triggeringHwnd, GWL_STYLE);
				uFlags ^=  WS_SYSMENU;
				SetWindowLong(triggeringHwnd, GWL_STYLE, uFlags);
				ShowWindow(triggeringHwnd, SW_HIDE);
				ShowWindow(triggeringHwnd, SW_SHOW);
				InvalidateRect(triggeringHwnd, NULL, FALSE);
			}
			break;
 
		case IDM_MINIMIZE:
			if (triggeringHwnd != NULL && IsWindow(triggeringHwnd)) {
				ShowWindow(triggeringHwnd, SW_MINIMIZE);
			}
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;



	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_USER:
		switch (lParam) {
		case WM_RBUTTONDOWN:
			GetCursorPos(&pt);
			menuH = GetSubMenu(hMenu, 0);
			triggeringHwnd = *DkmyLastHwndP;
			if (triggeringHwnd == NULL) {
				ModifyMenu(menuH, 0, MF_BYPOSITION | MF_STRING | MF_DISABLED | MF_GRAYED, 0, _T("No Window"));
				ModifyMenu(menuH, 1, MF_BYPOSITION | MF_STRING | MF_DISABLED | MF_GRAYED, 0, _T("Minimize"));
			}
			else {
				UINT uFlags = GetWindowLong(triggeringHwnd, GWL_STYLE) & WS_SYSMENU ? MF_CHECKED : MF_UNCHECKED;
				GetWindowText(triggeringHwnd, bufferS, sizeof(bufferS) - 1);
				//ModifyMenu(menuH, 0, MF_BYPOSITION | MF_STRING | uFlags, IDM_LOCK_UNLOCK, (bufferS[0] == '\0') ? _T("Untitled Window") : bufferS);
				ModifyMenu(menuH, 0, MF_BYPOSITION | MF_STRING, IDM_LOCK_UNLOCK, uFlags  == MF_CHECKED ? _T("Lock") : _T("Unlock"));
				ModifyMenu(menuH, 1, MF_BYPOSITION | MF_STRING, IDM_MINIMIZE, _T("Minimize"));
			}

			TrackPopupMenu(menuH, TPM_LEFTALIGN |TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);
			break;

		case WM_LBUTTONDBLCLK:
			triggeringHwnd = *DkmyLastHwndP;
			PostMessage(hWnd, WM_COMMAND, IDM_LOCK_UNLOCK, 0);
			break;

		default:
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}


BOOL InstallShellHook()
{
	dllModuleH = LoadLibrary("Dkmy.dll");
	if (dllModuleH == NULL) {
		MessageBox(GetDesktopWindow(), _T("Cannot load Dkmy DLL"), _T("DKMY"), MB_ICONERROR);
		return FALSE;
	}

	DkmyHookHP = reinterpret_cast<HHOOK*>(GetProcAddress(dllModuleH, "DkmyHookH"));
	DkmyLastHwndP = reinterpret_cast<HWND*>(GetProcAddress(dllModuleH, "DkmyLastHwnd"));
	DkmyNumInstancesP = reinterpret_cast<DWORD*>(GetProcAddress(dllModuleH, "DkmyNumInstances"));
	shellProc = reinterpret_cast<HOOKPROC>(GetProcAddress(dllModuleH, "DkmyShellProc"));

	if (shellProc == NULL || DkmyHookHP == NULL || DkmyLastHwndP == NULL || DkmyNumInstancesP == NULL) {
		MessageBox(GetDesktopWindow(), _T("Invalid Shell Hook DLL."), _T("DKMY"), MB_ICONERROR);
		FreeLibrary(dllModuleH);
		dllModuleH = NULL;
		return FALSE;
	}	

	if (*DkmyNumInstancesP != 0) {
		MessageBox(GetDesktopWindow(), _T("DKMY is already running."), _T("DKMY"), MB_ICONERROR);
		FreeLibrary(dllModuleH);
		dllModuleH = NULL;
		return FALSE;
	}

	++(*DkmyNumInstancesP);

	hookH = SetWindowsHookEx(WH_SHELL, shellProc, dllModuleH, 0);
	if (hookH == NULL) {
		MessageBox(GetDesktopWindow(), _T("Failed to install Shell Hook."), _T("DKMY"), MB_ICONERROR);
		FreeLibrary(dllModuleH);
		dllModuleH = NULL;
		return FALSE;
	}

	*DkmyHookHP = hookH;
	return TRUE;
}


VOID RemoveShellHook()
{
	if (*DkmyNumInstancesP) --(*DkmyNumInstancesP);
	if (hookH) UnhookWindowsHookEx(hookH);
	if (dllModuleH) FreeLibrary(dllModuleH);
}
